# pred.delta.11= 

pred.delta.11 = matrix(NA, ncol=ncol(EN.11), nrow=nrow(EN.11))
pred.delta.ub.11 = matrix(NA, ncol=ncol(EN.11), nrow=nrow(EN.11))
pred.delta.lb.11 = matrix(NA, ncol=ncol(EN.11), nrow=nrow(EN.11))
pred.delta.var.11 = matrix(NA, ncol=ncol(EN.11), nrow=nrow(EN.11))
# i=1
# t=1
Bias.11 = EN.11 - WRF.11
for(i in 1:S.11){
  for(j in 1:T){
    y = Bias.11[j,-i]
    mod.11 = lm(y~1)
    summary(mod.11)
    # n = length(y)
    # sse <- sum((y - fitted(mod.11))^2)
    # mse <- sse / (n - 1)
    # sigma(mod.11)
    # mse = summary(mod.11)$sigma
    # t.val <- qt(0.975, n - 1) # Critical value of t
    # pred.se.fit <- (1 + (1 / n)) # Standard error of the prediction
    # pred.conf.upper <- coef(mod.11) + t.val * sqrt(mse * pred.se.fit)
    # pred.conf.lower <- coef(mod.11) - t.val * sqrt(mse * pred.se.fit)
    predict(mod.11, interval="predict",se.fit = TRUE)
    pred = WRF.pred.11[j,i] + predict(mod.11, interval="predict")[1,]
    pred.delta.11[j,i] = pred[1]
    pred.delta.lb.11[j,i] = pred[2]
    pred.delta.ub.11[j,i] = pred[3]
    pred.delta.var.11[j,i] = sigma(mod.11)^2
  }
}


plot(pred.delta.11[,1], type="l", xlab="t", ylab="Y", ylim=ylimit, main="Temporal correction")
for(i in 2:10){
  lines(pred.delta.11[,i])
}


library(Metrics)
library(verification)
rmse.delta.11 = crps.delta.11 = matrix(NA, S.11,1)
for(i in 1:S.11){
  rmse.delta.11[i] = rmse( EN.11[,i], pred.delta.11[,i] )
  crps.delta.11[i] = crps( EN.11[,i], cbind(pred.delta.11[,i],  sqrt(pred.delta.var.11[,i])))$CRPS
}
round(mean(rmse.delta.11),2)
round(sd(rmse.delta.11),2)
round(mean(crps.delta.11),2)
round(sd(crps.delta.11),2)

