##############################
#Ex1########
##############################
S=10
set.seed(550)
s1 = runif(S, 0, 1)
s2 = runif(S, 0, 1)
plot(s1, s2)

T=100
t = 1:T
fh.10 = function(tt,ss1,ss2){
  yl.10 = 2/3*exp(ss1+ss2)*(0.01+0.001*tt+0.0005*tt^2) - 4*sin(50*tt)
  fh.10 = (1.2+cos(tt)/10+(2*ss1^2-ss2^2))*yl.10-(1+sin(tt)/10+(ss1+ss2)) + rnorm(1, 0, 0.1)
  return(fh.10)
}
yh.10 = matrix(NA, T, S)
yl.10 = matrix(NA, T, S)

for(i in 1:S){
  for(j in 1:T){
    yh.10[j, i] = fh.10(t[j], s1[i], s2[i])
    yl.10[j, i] = 2/3*exp(s1[i]+s2[i])*(0.01+0.001*t[j]+0.0005*t[j]^2) - 4*sin(50*t[j])
  }
}


plot(yh.10[,1], type="l", ylim=c(-15, 50), xlab="t", ylab="")
lines(yl.10[,1], col="blue")

for(i in 1:S){
  lines(yh.10[,i])
  lines(yl.10[,i], col="blue")
}
legend("topleft",legend=c("y","x"),
       col=c("black", "blue"), lty = 1)


##############################
#Ex3########
##############################
S=10
set.seed(536)
s1 = runif(S, 0, 1)
s2 = runif(S, 0, 1)
plot(s1, s2)

T=25
t=(1:T)+10

fh.11 = function(tt,ss1,ss2){
  yl.11 = cos(50*tt)+((s1[i]+ s2[i]))
  fh.11 = (ss1+ss2)*exp((ss1+ss2-0.3)*yl.11) -1 + rnorm(1, 0, 0.1^2)
  return(fh.11)
}
yh.11 = matrix(NA, T, S)
yl.11 = matrix(NA, T, S)

for(i in 1:S){
  for(j in 1:T){
    yh.11[j, i] = fh.11(t[j], s1[i], s2[i])+ rnorm(1, 0, 0.1^2)
    yl.11[j, i]  = cos(50*t[j])+((s1[i]+ s2[i]))+ rnorm(1, 0, 0.04)
    
  }
}

plot(yl.11[,1], type="l", ylim=c(-1.5, 5), main="", xlab="t", ylab="", col="blue")
lines(yh.11[,1], col=1)

for(i in 1:S){
  lines(yl.11[,i], col="blue")
  lines(yh.11[,i], col=1)
}
legend("topleft",
       legend=c("y","x"),
       col=c("black", "blue"), lty = 1)


##############################
#Ex4########
##############################

yl.5 = 2/3*exp(s1+s2) - sin(t)
yh.5 = 1.2*yl.5-1

T=25
t = 1:T

S=15
# set.seed(100)
set.seed(560)
s1 = runif(S, 0, 1)
s2 = runif(S, 0, 1)
plot(s1, s2)

fh.5 = function(t,s1,s2){
  fh.5 = 2/3*exp(s1+s2) - 4*sin(50*t)+ rnorm(T, 0, 0.1)
  yl.5 = 1.2*fh.5-1 
  return(fh.5)
}

yh.5 = matrix(NA, T, S)
for(i in 1:S){
  yh.5[, i] = fh.5(t, s1[i], s2[i])
}

yl.5 =  1.2*yh.5-1

plot(yh.5[,1], type="l", ylim=c(-10, 10))
for(i in 2:S){
  lines(yh.5[,i])
  lines(yl.5[,i], col="red")
}

