# rm(list=ls())

source("C:/Users/mapso/OneDrive/Desktop/bias correction/Final_code_data/util/nl2.R")

#############################################################
# 2011
#############################################################
y.pred.a.11 = y.pred.a.var.11 =  matrix(NA, nT, S.11)
y.pred.a.wrf.11 = y.pred.a.wrf.var.11=  matrix(NA, nT, S.11)

# ratio.st.11 = matrix(NA, S.11, 3)
# ratio.b.11 = matrix(NA, S.11, 3)
hyper.11 = matrix(NA, 4, S.11)
# beta.11 = matrix(NA, 2, S.11)
# 
# mean.fixed.11 = matrix(NA, nT, S.11)
# mean.Cn.0.11 = matrix(NA, nT, S.11)
# mean.Cn.1.11 = matrix(NA, nT, S.11)
# 
# mean.fixed.wrf.11 = matrix(NA, nT, S.11)
# mean.Cn.0.wrf.11 = matrix(NA, nT, S.11)
# mean.Cn.1.wrf.11 = matrix(NA, nT, S.11)

for(i in 1:S.11){
  print(i)
  
  y = c(EN.11[,-i])
  x = c(WRF.11[,-i])
  n = length(y)
  x1 = as.matrix(cbind(rep(1,n), na.approx(x)))
  x1.te = as.matrix(cbind(rep(1,nT), na.approx(WRF.11[,i])))
  x1.wrf.te = as.matrix(cbind(rep(1,nT), na.approx(WRF.pred.11[,i])))
  
  d = location.11[-i,]
  ds = distance(d)
  dt = sqrt(distance(1:nT))
  Dt = kronecker(ones(ncol(ds),ncol(ds)), dt)
  
  # prediction
  d.te = location.11[i,]
  Ds.all = kronecker( distance(rbind(d,d.te)), ones(nT, nT) )
  Ds.tr = Ds.all[1:((S.11-1)*nT), 1:((S.11-1)*nT)]
  Ds.trte = Ds.all[((S.11-1)*nT+1):(S.11*nT), 1:((S.11-1)*nT)]
  Ds.tete = Ds.all[((S.11-1)*nT+1):(S.11*nT), ((S.11-1)*nT+1):(S.11*nT)]
  
  dt = sqrt(distance(1:nT))
  Dt.all = kronecker(ones(S.11,S.11), dt)
  Dt.tr = Dt.all[1:((S.11-1)*nT), 1:((S.11-1)*nT)]
  Dt.trte = Dt.all[((S.11-1)*nT+1):(S.11*nT), 1:((S.11-1)*nT)]
  Dt.tete = Dt.all[((S.11-1)*nT+1):(S.11*nT), ((S.11-1)*nT+1):(S.11*nT)]
  
  counter <- 0
  # out <- optim(rep(0.8,8),
  out <- optim(rep(0.2,4),
               nl2,
               method="L-BFGS-B",
               lower=c(eps, eps, eps, eps),
               upper=c(Inf,(1-eps),Inf,Inf),
               Ds=Ds.tr,Dt=Dt.tr,Y=y)
  hyper.11[,i] = out$par
  length(out$par)
  out$par
  # theta.s0 = out$par[1]
  # theta.s1 = out$par[2]
  # rho.0 = out$par[3]
  # rho.1 = out$par[4]
  # delta.0_tau2 = out$par[5]
  # delta.1_tau2 = out$par[6]
  # tau2.1_tau2 = out$par[7]
  # g = out$par[8]
  
  theta.s0 <- out$par[1]
  rho.0 = out$par[2]
  delta.0_tau2 = out$par[3]
  g <- out$par[4]
  ################################################################
  # Define the kernel or covariance function for training data
  C0 = exp(-Ds.tr/theta.s0) + delta.0_tau2*(rho.0^Dt.tr)/(1-rho.0^2)
  # C1 = tau2.1_tau2 * exp(-Ds.tr/theta.s1) + delta.1_tau2*(rho.1^Dt.tr)/(1-rho.1^2)
  C2 =  diag(g, n)
  # K <- C0 + ( diag(na.approx(x)) %*% C1 %*% diag(na.approx(x)) ) + C2 
  K <- C0 + C2 
  #####################################################################################################################
  # trte
  C0.trte = exp(-Ds.trte/theta.s0) + delta.0_tau2*(rho.0^Dt.trte)/(1-rho.0^2)
  # C1.trte = tau2.1_tau2 * exp(-Ds.trte/theta.s1) + delta.1_tau2*(rho.1^Dt.trte)/(1-rho.1^2)
  C.trte <- C0.trte #+ ( diag(na.approx(x1.te[,2])) %*% C1.trte %*% diag(na.approx(x1[,2])) )
  # te
  C0.tete = exp(-Ds.tete/theta.s0) + delta.0_tau2*(rho.0^Dt.tete)/(1-rho.0^2)
  # C1.tete = tau2.1_tau2 * exp(-Ds.tete/theta.s1) + delta.1_tau2*(rho.1^Dt.tete)/(1-rho.1^2)
  C.tete <- C0.tete #+ ( diag(na.approx(x1.te[,2])) %*% C1.tete %*% diag(na.approx(x1.te[,2])) )
  
  ###additional covariance term
  C.trte.wrf <- C0.trte #+ ( diag(WRF.pred.11[,i]) %*% C1.trte %*% diag(na.approx(x1[,2])) ) 
  C.tete.wrf <- C0.tete #+ ( diag(WRF.pred.11[,i]) %*% C1.tete %*% diag(WRF.pred.11[,i]) )
  ################################################################
  Ki = solve(K)
  
  # Estimation of fixed effect (Mean of Y)
  beta.hat = solve( t(na.approx(x1))%*% Ki%*% na.approx(x1) ) %*% t( na.approx(x1) ) %*% Ki %*% na.approx(y)
  beta.hat
  beta.11[,i] = beta.hat
  
  tau2 = 1/n * t(na.approx(y)-x1%*% beta.hat) %*% Ki %*% (na.approx(y)-x1%*% beta.hat)
  tau2 = as.numeric(tau2)
  Sigmai= Ki/tau2
  
  # tau2.1 =  tau2.1_tau2 * tau2
  delta.0 = delta.0_tau2 * tau2
  # delta.1 = delta.1_tau2 * tau2
  sigma2 = tau2 * g
  
  #####################################################################################################################
  # Mean of GP
  mean.Cn = C.trte %*% Ki %*% (na.approx(y)-x1 %*% beta.hat)
  #####################################################################################################################
  # original data
  y.hat = x1.te %*% beta.hat + mean.Cn
  y.hat.var = tau2 * as.numeric(diag( C.tete - C.trte %*% Ki %*%  t(C.trte) )) + sigma2
  #############################################
  mean.fixed.11[,i] = x1.te %*% beta.hat
  mean.Cn.0.11[,i] = C0.trte %*% Ki %*% (na.approx(y)-x1 %*% beta.hat)
  # mean.Cn.1.11[,i] = ( diag(na.approx(x1.te[,2])) %*% C1.trte %*% diag(na.approx(x1[,2])) ) %*% Ki %*% (na.approx(y)-x1 %*% beta.hat)
  
  #####################################################################################################################
  # Mean of GP
  mean.Cn.wrf = C.trte.wrf %*% Ki %*% (na.approx(y)-x1 %*% beta.hat)
  ########## by the total law of variance
  # Ecc.a = tau2*diag(C0.tete) + (WRF.pred.11[,i]^2 + WRF.pred.var.11[,i]) * tau2*diag(C1.tete) + rep(sigma2, ncol(Dt.tete))
  # C0starDxC1starmu = t(tau2*C0.trte) + diag(na.approx(x1[,2]))%*%t(tau2*C1.trte)%*% diag(WRF.pred.11[,i])  
  # EcSigmac.a = diag(t(C0starDxC1starmu) %*% Sigmai %*% C0starDxC1starmu)
  # v.a = WRF.pred.var.11[,i] *(beta.hat[2] + tau2*C1.trte %*% diag(na.approx(x1[,2])) %*% Sigmai %*%  (na.approx(y)-x1%*% beta.hat))^2
  # WRF prediction data
  y.hat.wrf = x1.wrf.te %*% beta.hat + mean.Cn.wrf
  y.hat.wrf.var = tau2 * as.numeric(diag( C.tete - C.trte %*% Ki %*%  t(C.trte) )) + sigma2
  #############################################
  # mean.fixed.wrf.11[,i] = x1.wrf.te %*% beta.hat
  # mean.Cn.0.wrf.11[,i] = C0.trte %*% Ki %*% (na.approx(y)-x1 %*% beta.hat)
  # mean.Cn.1.wrf.11[,i] = ( diag(WRF.pred.11[,i]) %*% C1.trte %*% diag(na.approx(x1[,2])) ) %*% Ki %*% (na.approx(y)-x1 %*% beta.hat)
  
  y.pred.a.11[,i] = y.hat
  y.pred.a.var.11[,i] = y.hat.var
  y.pred.a.wrf.11[,i] = y.hat.wrf
  y.pred.a.wrf.var.11[,i] = y.hat.wrf.var
}


for(i in 1:10){
  plot(EN.11[,i], type="o", main=i, ylim=c(-10, 10))
  lines(y.pred.wrf.11[,i], col=2)
  lines(y.pred.a.wrf.11[,i], col=4)
}


# round(rmse(EN.11, y.pred.11),3)
# round(rmse(EN.11, y.pred.a.wrf.11),3)


round(rmse(EN.11, y.pred.wrf.11), 3)
round(rmse(EN.11, y.pred.a.wrf.11),3)
round(rmse(EN.11, WRF.pred.11),3)
round(rmse(EN.11, WRF.11),3)

round(rmse(EN.11, y.spat.gp.pred.11),3)

# ylimit = range(c(yl.11, yh.11, y.pred.wrf.11, y.pred.a.wrf.11))
ylimit = range(c(EN.11, WRF.11, y.pred.wrf.11, y.pred.a.wrf.11, y.pred.lm.11, pred.delta.11))
# ylimit = c(-80, 90)

# ylimit=range(c(EN.11, WRF.11, y.pred.wrf.11, y.pred.a.wrf.11), na.rm = T)

pdf(file = "C:/Users/mapso/OneDrive/Desktop/bias correction/Final_code_data/Figures/sim_4_v1.pdf",
    width = 6, # The width of the plot in inches
    height = 4.5) # The height of the plot in inches
par(mar=c(5.1, 4.1, 2.1, 2.1), mgp=c(3, 1, 0), las=0) #default / bottom, left, top, and right
plot(EN.11[,1], type="l", xlab="t", ylab="", ylim=ylimit, main="", col=1)
lines(WRF.11[,1], col=4)
# plot(y.pred.wrf.11[,1], type="l")
for(i in 2:10){
  lines(WRF.11[,i], col=4)
  lines(EN.11[,i], col=1)
}
legend("topright",legend=c("y", "x"), col=c(1,4), lty=1 ,cex=1)
# legend("topleft",legend=c("y", "x"), col=c(1,4), lty=1 ,cex=1)
dev.off()


pdf(file = "C:/Users/mapso/OneDrive/Desktop/bias correction/Final_code_data/Figures/sim_4_STerror_v1.pdf",
    width = 6, # The width of the plot in inches
    height = 4.5) # The height of the plot in inches
par(mar=c(5.1, 4.1, 2.1, 2.1), mgp=c(3, 1, 0), las=0) #default / bottom, left, top, and right
plot(y.pred.a.wrf.11[,1], type="l", col=2, xlab="t", ylab="", ylim=ylimit, main="")
for(i in 2:10){
  lines(y.pred.a.wrf.11[,i], col=2)
}
dev.off()

pdf(file = "C:/Users/mapso/OneDrive/Desktop/bias correction/Final_code_data/Figures/sim_4_STerror_v2.pdf",
    width = 6, # The width of the plot in inches
    height = 4.5) # The height of the plot in inches
par(mar=c(5.1, 4.1, 2.1, 2.1), mgp=c(3, 1, 0), las=0) #default / bottom, left, top, and right
plot(y.pred.a.wrf.11[,1], type="l", col=2, xlab="t", ylab="", ylim=ylimit, main="")
lines(EN.11[,1])
for(i in 2:10){
  lines(y.pred.a.wrf.11[,i], col=2)
  lines(EN.11[,i])
}
legend("topright",legend=c("y", expression(hat(y))), col=c(1,2), lty=1 ,cex=1)
dev.off()



pdf(file = "C:/Users/mapso/OneDrive/Desktop/bias correction/Final_code_data/Figures/sim_4_LM_v2.pdf",
    width = 6, # The width of the plot in inches
    height = 4.5) # The height of the plot in inches
par(mar=c(5.1, 4.1, 2.1, 2.1), mgp=c(3, 1, 0), las=0) #default / bottom, left, top, and right
plot(y.pred.lm.11[,1], type="l", col=2, xlab="t", ylab="", ylim=ylimit, main="")
lines(EN.11[,1])
for(i in 2:10){
  lines(y.pred.lm.11[,i], col=2)
  lines(EN.11[,i])
}
legend("topright", legend=c("y", expression(hat(y))), col=c(1,2), lty=1)
dev.off()


pdf(file = "C:/Users/mapso/OneDrive/Desktop/bias correction/Final_code_data/Figures/sim_4_PM_v1.pdf",
    width = 6, # The width of the plot in inches
    height = 4.5) # The height of the plot in inches
par(mar=c(5.1, 4.1, 2.1, 2.1), mgp=c(3, 1, 0), las=0) #default / bottom, left, top, and right
plot(y.pred.wrf.11[,1], type="l", col=2, xlab="t", ylab="Y", ylim=ylimit, main="")
# plot(y.pred.wrf.11[,1], type="l")
for(i in 2:10){
  lines(y.pred.wrf.11[,i], col=2)
}
dev.off()


pdf(file = "C:/Users/mapso/OneDrive/Desktop/bias correction/Final_code_data/Figures/sim_4_PM_v2.pdf",
    width = 6, # The width of the plot in inches
    height = 4.5) # The height of the plot in inches
par(mar=c(5.1, 4.1, 2.1, 2.1), mgp=c(3, 1, 0), las=0) #default / bottom, left, top, and right
plot(y.pred.wrf.11[,1], type="l", col=2, xlab="t", ylab="Y", ylim=ylimit, main="")
lines(EN.11[,1])
# plot(y.pred.wrf.11[,1], type="l")
for(i in 2:10){
  lines(y.pred.wrf.11[,i], col=2)
  lines(EN.11[,i])
}
legend("topright",legend=c("y", expression(hat(y))), col=c(1,2), lty=1 ,cex=1)
dev.off()


pdf(file = "C:/Users/mapso/OneDrive/Desktop/bias correction/Final_code_data/Figures/sim_1_spatialGP_v1.pdf",
    width = 6, # The width of the plot in inches
    height = 4.5) # The height of the plot in inches
par(mar=c(5.1, 4.1, 2.1, 2.1), mgp=c(3, 1, 0), las=0) #default / bottom, left, top, and right
plot(y.spat.gp.pred.11[,1], type="l", xlab="t", ylab="Y", ylim=ylimit, main="", col=2)
# plot(y.pred.wrf.11[,1], type="l")
for(i in 2:10){
  lines(y.spat.gp.pred.11[,i], col=2)
}
dev.off()


pdf(file = "C:/Users/mapso/OneDrive/Desktop/bias correction/Final_code_data/Figures/sim_1_spatialGP_v2.pdf",
    width = 6, # The width of the plot in inches
    height = 4.5) # The height of the plot in inches
par(mar=c(5.1, 4.1, 2.1, 2.1), mgp=c(3, 1, 0), las=0) #default / bottom, left, top, and right
plot(y.spat.gp.pred.11[,1], type="l", xlab="t", ylab="Y", ylim=ylimit, main="", col=2)
# plot(y.pred.wrf.11[,1], type="l")
lines(EN.11[,1])
for(i in 2:10){
  lines(y.spat.gp.pred.11[,i], col=2)
  lines(EN.11[,i])
}
# legend("topright",legend=c("y", expression(hat(y))), col=c(1,2), lty=1 ,cex=1)
legend("topleft",legend=c("y", expression(hat(y))), col=c(1,2), lty=1 ,cex=1)
dev.off()

pdf(file = "C:/Users/mapso/OneDrive/Desktop/bias correction/Final_code_data/Figures/sim_1_temporalcor.pdf",
    width = 6, # The width of the plot in inches
    height = 4.5) # The height of the plot in inches
par(mar=c(5.1, 4.1, 2.1, 2.1), mgp=c(3, 1, 0), las=0) #default / bottom, left, top, and right
plot(pred.delta.11[,1], type="l", xlab="t", ylab="Y", ylim=ylimit, main="", col=2)
# plot(y.pred.wrf.11[,1], type="l")
for(i in 2:10){
  lines(pred.delta.11[,i], col=2)
}
dev.off()


pdf(file = "C:/Users/mapso/OneDrive/Desktop/bias correction/Final_code_data/Figures/sim_4_temporalcor_v2.pdf",
    width = 6, # The width of the plot in inches
    height = 4.5) # The height of the plot in inches
par(mar=c(5.1, 4.1, 2.1, 2.1), mgp=c(3, 1, 0), las=0) #default / bottom, left, top, and right
plot(pred.delta.11[,1], type="l", xlab="t", ylab="Y", ylim=ylimit, main="", col=2)
lines(EN.11[,1])
# plot(y.pred.wrf.11[,1], type="l")
for(i in 2:10){
  lines(pred.delta.11[,i], col=2)
  lines(EN.11[,i])
}
legend("topright",legend=c("y", expression(hat(y))), col=c(1,2), lty=1 ,cex=1)
dev.off()


# plot(yh.11[,1], type="l", xlab="t", ylab="Y", ylim=ylimit, main="High-accuracy model output")
# # plot(y.pred.wrf.11[,1], type="l")
# for(i in 2:10){
#   lines(yh.11[,i])
# }
# 
# plot(EN.11[,1], type="l", xlab="t", ylab="Y", ylim=ylimit, main="High-accuracy model output")
# # plot(y.pred.wrf.11[,1], type="l")
# for(i in 2:10){
#   lines(EN.11[,i])
# }
# 
# plot(WRF.11[,1], type="l", xlab="t", ylab="Y", ylim=ylimit, main="Low-accuracy model output", col=2)
# # plot(y.pred.wrf.11[,1], type="l")
# for(i in 2:10){
#   lines(WRF.11[,i], col=2)
# }
# 
# plot(WRF.pred.11[,1], type="l", xlab="t", ylab="Y", ylim=ylimit, main="Low-accuracy prediction", col=4)
# # plot(y.pred.wrf.11[,1], type="l")
# for(i in 2:10){
#   lines(WRF.pred.11[,i], col=4)
# }


# pdf(file = "C:/Users/mapso/OneDrive/Desktop/wind power forecast/wind_solar_station_met.pdf", 
#     width = 6, # The width of the plot in inches
#     height = 4.5) # The height of the plot in inches
# dev.off()


# save.image("C:/Users/mapso/OneDrive/Desktop/bias correction/Final_code_data/sim_study_y_a_v5.RData")
# setwd("C:/Users/mapso/OneDrive/Desktop/bias correction/Final_code_data")
